using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using Webolize.TimeTracker.Domain;

using Cuyahoga.Core.Util;
using Cuyahoga.Web.UI;

namespace Webolize.TimeTracker.Web.Admin
{
	/// <summary>
	/// Summary description for Edit Forums.
	/// </summary>
    public class EditBillableNote : ModuleAdminBasePage
	{
        protected System.Web.UI.WebControls.DropDownList wf_BillableTypes;
        protected System.Web.UI.WebControls.TextBox wf_Title;
        protected System.Web.UI.WebControls.TextBox wf_Notes;
        protected System.Web.UI.WebControls.CheckBox wf_IsCustom;
        protected System.Web.UI.WebControls.CheckBox wf_Active;
        protected System.Web.UI.WebControls.LinkButton wf_Submit;
        protected System.Web.UI.WebControls.Label wf_Status;

		private TimeTrackerModule _module;
        private int billableNoteID;

		private void Page_Load(object sender, System.EventArgs e)
		{
			base.Title = "Webolize TimeTracker Administration";
			this._module = base.Module as TimeTrackerModule;

            if ( Request.QueryString["BillableNoteID"] != null ) {
                billableNoteID = Int32.Parse( Request.QueryString["BillableNoteID"] );
            } else {
                billableNoteID = -1;
            }

			if (! this.IsPostBack)
			{
                BindData();
			}
		}

        private void BindData()
        {
            TimeTrackerDB ttdb = new TimeTrackerDB( _module.SessMgr );

            if ( billableNoteID >= 0 ) {
                TTBillableNote bn = ttdb.GetSingleBillableNote( billableNoteID );

                wf_BillableTypes.SelectedValue = bn.BillableType;
                wf_Title.Text = bn.Title;
                wf_Notes.Text = bn.Notes;
                wf_IsCustom.Checked = bn.IsCustom;
                wf_Active.Checked = bn.Active;

                wf_Status.Visible = false;
            } else {
                wf_Active.Checked = true;

                wf_Submit.Text = "create billable note";
            }
        }


        protected void wf_Submit_Click( object sender, EventArgs e )
        {
            Cuyahoga.Core.Domain.User _currentUser = Context.User.Identity as Cuyahoga.Core.Domain.User;
            TimeTrackerDB ttdb = new TimeTrackerDB( _module.SessMgr );
            TTBillableNote bt;

            if ( billableNoteID >= 0 ) {
                bt = ttdb.GetSingleBillableNote( billableNoteID );
            } else {
                bt = new TTBillableNote();
            }

            bt.BillableType = wf_BillableTypes.SelectedValue;
            bt.Title = wf_Title.Text;
            bt.Notes = wf_Notes.Text;
            bt.IsCustom = wf_IsCustom.Checked;
            bt.Active = wf_Active.Checked;
            bt.CreatedByID = _currentUser.Id;
            bt.CreatedDate = DateTime.Now;

            // Save or update
            if ( billableNoteID >= 0 ) {
                ttdb.Update( bt );
                wf_Status.Text = "billable note has been updated";
                wf_Status.Visible = true;
            } else {
                ttdb.Save( bt );
                wf_Back_Click( sender, e );
            }

        }

        protected void wf_Back_Click( object sender, EventArgs e )
        {
            Response.Redirect( String.Format("~/Modules/Webolize-TimeTracker/Admin/Admin.aspx?NodeId={0}&SectionId={1}", this.Node.Id, this.Section.Id ) );
        }

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
