using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using Webolize.TimeTracker.Domain;

using Cuyahoga.Core.Util;
using Cuyahoga.Web.UI;

namespace Webolize.TimeTracker.Web.Admin
{
	/// <summary>
	/// Summary description for Edit Forums.
	/// </summary>
    public class EditExpenseCode : ModuleAdminBasePage
	{
        protected System.Web.UI.WebControls.TextBox wf_FullName;
        protected System.Web.UI.WebControls.TextBox wf_Description;
        protected System.Web.UI.WebControls.TextBox wf_MarkupMultiplier;
        protected System.Web.UI.WebControls.CheckBox wf_Active;
        protected System.Web.UI.WebControls.LinkButton wf_Submit;
        protected System.Web.UI.WebControls.Label wf_Status;

		private TimeTrackerModule _module;
        private int expenseCodeID;

		private void Page_Load(object sender, System.EventArgs e)
		{
			base.Title = "Webolize TimeTracker Administration";
			this._module = base.Module as TimeTrackerModule;

            if ( Request.QueryString["ExpenseCodeID"] != null ) {
                expenseCodeID = Int32.Parse( Request.QueryString["ExpenseCodeID"] );
            } else {
                expenseCodeID = -1;
            }

			if (! this.IsPostBack)
			{
                BindData();
			}
		}

        private void BindData()
        {
            TimeTrackerDB ttdb = new TimeTrackerDB( _module.SessMgr );

            if ( expenseCodeID >= 0 ) {
                TTExpenseCode ttec = ttdb.GetSingleExpenseCode( expenseCodeID );

                wf_FullName.Text = ttec.FullName;
                wf_Description.Text = ttec.Description;
                wf_MarkupMultiplier.Text = ttec.MarkupMultiplier.ToString( "0.00" );
                wf_Active.Checked = ttec.Active;

                wf_Status.Visible = false;
            } else {
                wf_MarkupMultiplier.Text = "1.00";
                wf_Active.Checked = true;

                wf_Submit.Text = "create expense code";
            }
        }


        protected void wf_Submit_Click( object sender, EventArgs e )
        {
            Cuyahoga.Core.Domain.User _currentUser = Context.User.Identity as Cuyahoga.Core.Domain.User;
            TimeTrackerDB ttdb = new TimeTrackerDB( _module.SessMgr );
            TTExpenseCode ec;

            if ( expenseCodeID >= 0 ) {
                ec = ttdb.GetSingleExpenseCode( expenseCodeID );
            } else {
                ec = new TTExpenseCode();
            }

            ec.FullName = wf_FullName.Text;
            ec.Description = wf_Description.Text;
            ec.MarkupMultiplier = Decimal.Parse(wf_MarkupMultiplier.Text);
            ec.Active = wf_Active.Checked;
            ec.CreatedByID = _currentUser.Id;
            ec.CreatedDate = DateTime.Now;            

            // Save or update ServiceType
            if ( expenseCodeID >= 0 ) {
                ttdb.Update( ec );
                wf_Status.Text = "expense code has been updated";
                wf_Status.Visible = true;
            } else {
                ttdb.Save( ec );
                wf_Status.Text = "expense code has been created";
                wf_Status.Visible = true;
            }

        }

        protected void wf_Back_Click( object sender, EventArgs e )
        {
            Response.Redirect( String.Format("~/Modules/Webolize-TimeTracker/Admin/Admin.aspx?NodeId={0}&SectionId={1}", this.Node.Id, this.Section.Id ) );
        }

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
