using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using Webolize.TimeTracker.Domain;

using Cuyahoga.Core.Util;
using Cuyahoga.Web.UI;

namespace Webolize.TimeTracker.Web.Admin
{
	/// <summary>
	/// Summary description for Edit Forums.
	/// </summary>
    public class EditServiceType : ModuleAdminBasePage
	{
        protected System.Web.UI.WebControls.TextBox wf_ShortName;
        protected System.Web.UI.WebControls.TextBox wf_FullName;
        protected System.Web.UI.WebControls.TextBox wf_Description;
        protected System.Web.UI.WebControls.TextBox wf_Rate;
        protected System.Web.UI.WebControls.CheckBox wf_Active;
        protected System.Web.UI.WebControls.LinkButton wf_Submit;
        protected System.Web.UI.WebControls.Label wf_Status;

		private TimeTrackerModule _module;
        private int serviceTypeID;

		private void Page_Load(object sender, System.EventArgs e)
		{
			base.Title = "Webolize TimeTracker Administration";
			this._module = base.Module as TimeTrackerModule;

            if ( Request.QueryString["ServiceTypeId"] != null ) {
                serviceTypeID = Int32.Parse( Request.QueryString["ServiceTypeId"] );
            } else {
                serviceTypeID = -1;
            }

			if (! this.IsPostBack)
			{
                BindData();
			}
		}

        private void BindData()
        {
            TimeTrackerDB ttdb = new TimeTrackerDB( _module.SessMgr );

            if ( serviceTypeID >= 0 ) {
                TTServiceType ttst = ttdb.GetSingleServiceType( serviceTypeID );

                wf_ShortName.Text = ttst.ShortName;
                wf_FullName.Text = ttst.Name;
                wf_Description.Text = ttst.Description;
                wf_Rate.Text = ttst.RatePerHour.ToString( "0.00" );
                wf_Active.Checked = ttst.Active;

                wf_Status.Visible = false;
            } else {
                wf_Rate.Text = "0.00";
                wf_Active.Checked = true;

                wf_Submit.Text = "create service type";
            }
        }


        protected void wf_Submit_Click( object sender, EventArgs e )
        {
            Cuyahoga.Core.Domain.User _currentUser = Context.User.Identity as Cuyahoga.Core.Domain.User;
            TimeTrackerDB ttdb = new TimeTrackerDB( _module.SessMgr );
            TTServiceType st;

            if ( serviceTypeID >= 0 ) {
                st = ttdb.GetSingleServiceType( serviceTypeID );
            } else {
                st = new TTServiceType();
            }

            st.ShortName = wf_ShortName.Text;
            st.Name = wf_FullName.Text;
            st.Description = wf_Description.Text;
            st.RatePerHour = Decimal.Parse(wf_Rate.Text);
            st.Active = wf_Active.Checked;
            st.CreatedByID = _currentUser.Id;
            st.CreatedDate = DateTime.Now;            

            // Save or update ServiceType
            if ( serviceTypeID >= 0 ) {
                ttdb.Update( st );
                wf_Status.Text = "service type has been updated";
                wf_Status.Visible = true;
            } else {
                ttdb.Save( st );
                wf_Status.Text = "service type has been created";
                wf_Status.Visible = true;
            }

        }

        protected void wf_Back_Click( object sender, EventArgs e )
        {
            Response.Redirect( String.Format("~/Modules/Webolize-TimeTracker/Admin/Admin.aspx?NodeId={0}&SectionId={1}", this.Node.Id, this.Section.Id ) );
        }

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
